DECLARE FUNCTION FvonXundY! (x!, y!)
' Funktionsdarstellung dreidimensional in dimetrischer Darstellung aus
' Dreickpolygone zusammengesetzt; ausserdem entsprechende Schattierung
' fr CGA-Grafikkarte (HiRes-Modus), Version fr QuickBASIC

DECLARE SUB ZeiHLinie (x1%, x2%, y%, f%)
DECLARE SUB ZeiDreieck (x1!, y1!, x2!, y2!, x3!, y3!, f%)
DECLARE SUB BereiteEVekt (Al!, Be!, xi!, xa!, yi!, ya!, zi!, za!)
DECLARE SUB ZeichneRDrei (xe1!, ye1!, ze1!, xe2!, ye2!, ze2!, xe3!, ye3!, ze3!, f%)
DECLARE SUB SetzePunkt (x%, y%, FTon%)
DECLARE FUNCTION FvonXundY! (x!, y!)
DECLARE FUNCTION xKomp! (x!, y!, z!)
DECLARE FUNCTION yKomp! (x!, y!, z!)

' Globale Variablen
DIM SHARED Pi!, xx!, xy!, yx!, yy!, zx!, zy!, x0!, y0!
DIM SHARED xi!, xa!, yi!, ya!, zi!, za!, AusdX!, AusdY!, AusdZ!
DIM SHARED Ht%(127)

' Hilfstabelle fr Schattierung-Dithering einrichten
h1% = 1
h2% = 128
FOR i% = 0 TO 6
  h2% = h2% \ 2
  FOR j% = 0 TO 127
    IF j% AND h2% THEN
      Ht%(j%) = Ht%(j%) + h1%
    END IF
  NEXT j%
  h1% = 4 * h1%
NEXT i%

SCREEN 2: CLS
Pi! = 4! * ATN(1!)

BereiteEVekt 25!, 57!, -6!, 16!, -6!, 6!, -3.1, 3.1

sx% = 11: sy% = 8    ' Anzahl Farbabstufungen (Schachbrettkaro)
ax% = 20: ay% = 20   ' Auflsung (Zahl der Dreiecke pro Schachbrettkaro)
px! = 1.2            ' Parameter fr den Schattenkontrast (je grsser, desto
py! = .4             ' strkere Farbtonunterschiede)

DIM za!(sx% * ax%)

xs! = AusdX! / CSNG(sx% * ax%)
ys! = AusdY! / CSNG(sy% * ay%)
za!(0) = FvonXundY!(xi!, yi!)
zMi! = za!(0)
zMa! = za!(0)
FOR i% = 1 TO sx% * ax%
  za!(i%) = FvonXundY!(xi! + CSNG(i%) * xs!, yi!)
  IF za!(i%) > zMa! THEN
    zMa! = za!(i%)
  END IF
  IF za!(i%) < zMi! THEN
    zMi! = za!(i%)
  END IF
NEXT i%

qx! = px! / xs!
qy! = py! / ys!
ay! = yi!
FOR fy% = 1 TO sy% * ay%
  wy! = yi! + CSNG(fy%) * ys!
  z1! = FvonXundY!(xi!, wy!)
  IF z1! > zMa! THEN
    zMa! = z1!
  END IF
  IF z1! < zMi! THEN
    zMi! = z1!
  END IF
  bcy% = (fy% - 1) \ ay% AND 1
  ax! = xi!
  FOR fx% = 1 TO sx% * ax%
    wx! = xi! + CSNG(fx%) * xs!
    c1% = CINT(ATN((za!(fx%) - za!(fx% - 1)) * qx! + (za!(fx% - 1) - z1!) * qy!) * 10922! / Pi!)
    bcx% = (fx% - 1) \ ax% AND 1
    f% = 5461 + 5461 * (bcx% XOR bcy%) + c1%
    ZeichneRDrei ax!, wy!, z1!, ax!, ay!, za!(fx% - 1), wx!, ay!, za!(fx%), f%
    za!(fx% - 1) = z1!
    za! = z1!
    z1! = FvonXundY!(wx!, wy!)
    IF z1! > zMa! THEN
      zMa! = z1!
    END IF
    IF z1! < zMi! THEN
      zMi! = z1!
    END IF
    c1% = CINT(ATN((z1! - za!(fx% - 1)) * qx! + (za!(fx%) - z1!) * qy!) * 10922! / Pi!)
    f% = 5461 + 5641 * (bcx% XOR bcy%) + c1%
    ZeichneRDrei ax!, wy!, za!(fx% - 1), wx!, wy!, z1!, wx!, ay!, za!(fx%), f%
    ax! = wx!
  NEXT fx%
  ZeichneRDrei xa!, ay!, za!(sx% * ax%), xa!, wy!, z1!, xa!, ay!, zi!, 5120
  ZeichneRDrei xa!, wy!, zi!, xa!, wy!, z1!, xa!, ay!, zi!, 5120
  za!(sx% * ax%) = z1!
  ay! = wy!
NEXT fy%
xa! = xi!
FOR fx% = 1 TO sx% * ax%
  x! = xi! + CSNG(fx%) * xs!
  ZeichneRDrei xa!, ya!, zi!, xa!, ya!, za!(fx% - 1), x!, ya!, za!(fx%), 14336
  ZeichneRDrei xa!, ya!, zi!, x!, ya!, zi!, x!, ya!, za!(fx%), 14336
  xa! = x!
NEXT fx%

WHILE INKEY$ = "": WEND
    
SCREEN 2: SCREEN 0
PRINT "Die beiden Z-Wert-Begrenzungen:"
PRINT "Das kleinste z :"; zMi!
PRINT "Das grsste  z :"; zMa!
END

SUB BereiteEVekt (Al!, Be!, xi1!, xa1!, yi1!, ya1!, zi1!, za1!)
  ' Dreidimensionale Koordinaten umrechnen: Berechnung der Umrechnungs-
  ' faktoren
  ' Eingangsvariablen:
  ' xi!, xa! : XMin und XMax des Raumquaders
  ' yi!, ya! : YMin und YMax des Raumquaders
  ' zi!, za! : ZMin und ZMax des Raumquaders
  ' Al! : Ansichtswinkel  (um sowiel wird das Auge von oben her gesehen
  '       abgedreht)
  ' Be! : Ansichtswinkel  (so steil sieht das Auge von oben her herunter)
  ' Ausgangsvariablen:
  ' (Im Hauptprogramm mit DIM SHARED global definieren!)
  ' xx!,xy!,yx!,yy!,zx!,zy! : Umrechnungsfaktoren (erster Buchstabe fr den
  '                           dimensionalen Koordinaten entsprechend, der
  '                           zweite fr den Bildschirm)
  ' x0!, y0!                : Nullpunkt des 3D-Koordinatensystems auf dem
  '                           Bildschirm
 
  xi! = xi1!: xa! = xa1!
  yi! = yi1!: ya! = ya1!
  zi! = zi1!: za! = za1!
  AusdX! = xa! - xi!
  AusdY! = ya! - yi!
  AusdZ! = za! - zi!
  Alr! = Al! * Pi! / 180!
  Ber! = Be! * Pi! / 180!
  xx! = COS(Alr!) * 12!
  xy! = SIN(Ber!) * SIN(Alr!) * 5!
  yx! = -SIN(Alr!) * 12!
  yy! = SIN(Ber!) * COS(Alr!) * 5!
  zx! = 0! * 12!
  zy! = -COS(Ber!) * 5!
  xBreite! = ABS(xx! * AusdX!) + ABS(yx! * AusdY!) + ABS(zx! * AusdZ!)
  yBreite! = ABS(xy! * AusdX!) + ABS(yy! * AusdY!) + ABS(zy! * AusdZ!)
  xf! = 638! / xBreite!
  yf! = 198! / yBreite!
  IF xf! < yf! THEN
    f! = xf!
  ELSE
    f! = yf!
  END IF
  xx! = xx! * f!
  yx! = yx! * f!
  xy! = xy! * f!
  yy! = yy! * f!
  zx! = zx! * f!
  zy! = zy! * f!
  x0! = 319.5 - xx! * (xi! + xa!) / 2! - yx! * (yi! + ya!) / 2! - zx! * (zi! + za!) / 2!
  y0! = 99.5 - xy! * (xi! + xa!) / 2! - yy! * (yi! + ya!) / 2! - zy! * (zi! + za!) / 2!
END SUB

FUNCTION FvonXundY! (x!, y!) STATIC
  ' Hier muss die eigentliche Funktion definiert werden
  x1! = x! - 10!
  y2! = y! * y!
  a1! = SQR(x! * x! + y2!)
  a2! = SQR(x1! * x1! + y2!)
  FvonXundY! = COS(4! * a1!) * EXP(-a1! / 5!) + COS(4! * a2!) * EXP(-a2! / 5!)
END FUNCTION

SUB SetzePunkt (x%, y%, FTon%)
  PSET (x%, y%), -(FTon% > 2 * Ht%(x% + y% AND 127) + Ht%(x% AND 127))
END SUB

FUNCTION xKomp! (x!, y!, z!) STATIC
  xKomp! = x0! + x! * xx! + y! * yx! + z! * zx!
END FUNCTION

FUNCTION yKomp! (x!, y!, z!) STATIC
  yKomp! = y0! + x! * xy! + y! * yy! + z! * zy!
END FUNCTION

SUB ZeichneRDrei (xe1!, ye1!, ze1!, xe2!, ye2!, ze2!, xe3!, ye3!, ze3!, f%) STATIC
  ' Zeichnet ein geflltes Dreieck in den Raum hinein
  ' Eingangsparameter:
  ' xe1!,ye1!,ze1!,xe2!,ye2!,ze2!,xe3!,ye3!,ze3!:
  ' Raumkoordinaten der 3 Eckpunkte
  ' f% : Farbton

  x1! = xKomp!(xe1!, ye1!, ze1!)
  y1! = yKomp!(xe1!, ye1!, ze1!)
  x2! = xKomp!(xe2!, ye2!, ze2!)
  y2! = yKomp!(xe2!, ye2!, ze2!)
  x3! = xKomp!(xe3!, ye3!, ze3!)
  y3! = yKomp!(xe3!, ye3!, ze3!)
  ZeiDreieck x1!, y1!, x2!, y2!, x3!, y3!, f%
END SUB

SUB ZeiDreieck (x1!, y1!, x2!, y2!, x3!, y3!, f%) STATIC
  ' Unterprogramm ZeichneGeflltesDreieck
  ' Eingangsvariablen:
  ' x1!,y1!,x2!,y2!,x3!,y3! : Eckpunkte des Dreieckes
  ' f%                      : Fllfarbe

  h1! = x1!
  v1! = y1!
  h2! = x2!
  v2! = y2!
  h3! = x3!
  v3! = y3!
  IF v1! > v2! THEN
    SWAP v1!, v2!
    SWAP h1!, h2!
  END IF
  IF v1! > v3! THEN
    SWAP v1!, v3!
    SWAP h1!, h3!
  END IF
  IF v2! > v3! THEN
    SWAP v2!, v3!
    SWAP h2!, h3!
  END IF
  dy! = v2! - v1!
  IF dy! <> 0! THEN
    s12! = (h2! - h1!) / dy!
    a12! = h1! - v1! * s12!
  END IF
  dy! = v3! - v1!
  IF dy! <> 0! THEN
    s13! = (h3! - h1!) / dy!
    a13! = h1! - v1! * s13!
  END IF
  dy! = v3! - v2!
  IF dy! <> 0! THEN
    s23! = (h3! - h2!) / dy!
    a23! = h2! - v2! * s23!
  END IF
  sf% = v2! * s13! + a13! < h2!
  y1% = CINT(INT(v1!)) + 1
  y2% = CINT(INT(v2!))
  y3% = CINT(INT(v3!))
  FOR y% = y1% TO y2%
    y! = CSNG(y%): x1% = CINT(INT(y! * s12! + a12!))
    x2% = CINT(INT(y! * s13! + a13!))
    IF sf% THEN
      ZeiHLinie x2%, x1%, y%, f%
    ELSE
      ZeiHLinie x1%, x2%, y%, f%
    END IF
  NEXT y%
  FOR y% = y2% + 1 TO y3%
    y! = CSNG(y%)
    x1% = CINT(INT(y! * s23! + a23!))
    x2% = CINT(INT(y! * s13! + a13!))
    IF sf% THEN
      ZeiHLinie x2%, x1%, y%, f%
    ELSE
      ZeiHLinie x1%, x2%, y%, f%
    END IF
  NEXT y%
END SUB

SUB ZeiHLinie (x1%, x2%, y%, f%) STATIC
  ' f% : Schattierfarbe (0 - 16384): Da nur Schwarz-Weiss,
  ' keine Unterteilung mglich

  FOR x% = x1% + 1 TO x2%
    SetzePunkt x%, y%, f%
  NEXT x%
END SUB

